#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"

#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "KBD.h"
#include "adc.h"
#include "tm_hd44780.h"

#define KBD_MEAN 20

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	uint32_t adcData[2], mean = 0;
	for( int i = 0 ; i < KBD_MEAN ; i++){
		adcReadCont(adcData,2);
		mean += adcData[1];
	}

	mean /= KBD_MEAN;

	kbdCheck(mean);
}

void kbdCallbackClick(uint8_t param){
	char text[20];
	//printf("Click\t %u\r\n", param);
	sprintf(text, "    Click  %u    ", param);
	TM_HD44780_Puts(0, 1, text);
}

void kbdCallbackHold(uint8_t param){
	char text[20];
	//printf("Hold\t %u\r\n", param);
	sprintf(text, "    Hold   %u    ", param);
	TM_HD44780_Puts(0, 1, text);
}

int main()
{ 
	//Inicjalizacja ADC
	adcInitCont();

	//szybkie wypenienie tablic definiujcych akcje przyciskw
	for(int i = 0 ; i < 5 ; i++){
		menu_items[i].click.action = kbdCallbackClick;
		menu_items[i].click.parameter = i;
		menu_items[i].hold.action = kbdCallbackHold;
		menu_items[i].hold.parameter = i;
	}

	//Ustawienie przerwania od timera i uruchomienie timera
	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);
	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK);

	TM_HD44780_Init(16, 2);
	TM_HD44780_BacklightOn();

	TM_HD44780_Puts(0, 0, "  TEST HD44780  ");

	while (1){

	}

	return 0;
}
