LIBRARY ieee  ; 
LIBRARY std  ; 
USE ieee.NUMERIC_STD.all  ; 
USE ieee.std_logic_1164.all  ; 
USE ieee.std_logic_textio.all  ; 
USE ieee.STD_LOGIC_UNSIGNED.all  ; 
USE ieee.std_logic_unsigned.all  ; 
USE std.textio.all  ; 
ENTITY PWM4_tb  IS 
END ; 
 
ARCHITECTURE PWM4_tb_arch   OF PWM4_tb   IS
  SIGNAL pwm   :  std_logic_vector (3 downto 0)  ; 
  SIGNAL read   :  STD_LOGIC  ; 
  SIGNAL reset_n   :  STD_LOGIC  ; 
  SIGNAL writedata   :  std_logic_vector (31 downto 0)  ; 
  SIGNAL readdata   :  std_logic_vector (31 downto 0)  ; 
  SIGNAL address   :  std_logic_vector (2 downto 0)  ; 
  SIGNAL clk   :  STD_LOGIC  ; 
  SIGNAL write   :  STD_LOGIC  ; 
  SIGNAL byteenable   :  std_logic_vector (3 downto 0)  ; 
  COMPONENT PWM4  
    PORT ( 
      pwm  : out std_logic_vector (3 downto 0) ; 
      read  : in STD_LOGIC ; 
      reset_n  : in STD_LOGIC ; 
      writedata  : in std_logic_vector (31 downto 0) ; 
      readdata  : out std_logic_vector (31 downto 0) ; 
      address  : in std_logic_vector (2 downto 0) ; 
      clk  : in STD_LOGIC ; 
      write  : in STD_LOGIC ; 
      byteenable  : in std_logic_vector (3 downto 0) ); 
  END COMPONENT ; 
BEGIN
  DUT  : PWM4  
    PORT MAP ( 
      pwm   => pwm  ,
      read   => read  ,
      reset_n   => reset_n  ,
      writedata   => writedata  ,
      readdata   => readdata  ,
      address   => address  ,
      clk   => clk  ,
      write   => write  ,
      byteenable   => byteenable   ) ; 



-- "Clock Pattern" : dutyCycle = 50
-- Start Time = 0 ns, End Time = 1 us, Period = 20 ns
  Process
	Begin
	 clk  <= '0'  ;
	wait for 10 ns ;
-- 10 ns, single loop till start period.
	for Z in 1 to 1000
	loop
	    clk  <= '1'  ;
	   wait for 10 ns ;
	    clk  <= '0'  ;
	   wait for 10 ns ;
-- 990 ns, repeat pattern in loop.
	end  loop;
	 clk  <= '1'  ;
	wait for 10 ns ;
-- dumped values till 1 us
	wait;
 End Process;
 
	process
	begin
	
	-- reset
	read 			<= '0';
	reset_n 		<= '0';
	writedata 	<= std_logic_vector(to_unsigned(0,writedata'length));
	address 		<= std_logic_vector(to_unsigned(0,address'length));
	write 		<= '0';
	byteenable 	<= "1111";
	wait for 30 ns;
	
	-- write data for ch0
	reset_n 		<= '1';
	writedata 	<= std_logic_vector(to_unsigned(0,writedata'length));
	address 		<= std_logic_vector(to_unsigned(0,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- write data for ch1
	writedata 	<= std_logic_vector(to_unsigned(10,writedata'length));
	address 		<= std_logic_vector(to_unsigned(1,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- write data for ch2
	writedata 	<= std_logic_vector(to_unsigned(20,writedata'length));
	address 		<= std_logic_vector(to_unsigned(2,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- write data for ch3
	writedata 	<= std_logic_vector(to_unsigned(30,writedata'length));
	address 		<= std_logic_vector(to_unsigned(3,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- write counterPrescMax
	writedata 	<= std_logic_vector(to_unsigned(3,writedata'length));
	address 		<= std_logic_vector(to_unsigned(4,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- write counterPWMMax
	writedata 	<= std_logic_vector(to_unsigned(30,writedata'length));
	address 		<= std_logic_vector(to_unsigned(5,address'length));
	write 		<= '1';
	wait for 20 ns;
	
	-- end write
	write			<= '0';
	
	-- read counterPWMMax
	address 		<= std_logic_vector(to_unsigned(5,address'length));
	read 			<= '1';
	wait for 20 ns;
	
	-- end read
	read 			<= '0';
	
	
	
	-- break this proces
	wait;
	
	
	end process;
END;
